# Generated by Django 2.0.8 on 2020-05-27 09:21

# Django
from django.db import migrations

# SquareletAuth
from squarelet_auth import settings


def entitlements(apps, schema_editor):
    Organization = apps.get_model(settings.ORGANIZATION_MODEL)
    Plan = apps.get_model("squarelet_auth_organizations", "Plan")
    Entitlement = apps.get_model("squarelet_auth_organizations", "Entitlement")

    for plan in Plan.objects.all():
        resources = {
            k: getattr(plan, k) for k in settings.RESOURCE_FIELDS if hasattr(plan, k)
        }
        entitlement = Entitlement.objects.create(
            name=plan.name, slug=plan.slug, resources=resources
        )
        Organization.objects.filter(plan=plan).update(entitlement=entitlement)


def delete_entitlements(apps, schema_editor):
    Organization = apps.get_model("organizations", "Organization")
    Entitlement = apps.get_model("organizations", "Entitlement")
    Organization.objects.update(entitlement=None)
    Entitlement.objects.all().delete()


class Migration(migrations.Migration):

    dependencies = [
        ("squarelet_auth_organizations", "0004_auto_20200527_0920"),
        migrations.swappable_dependency(settings.ORGANIZATION_MODEL),
    ]

    operations = [migrations.RunPython(entitlements, delete_entitlements)]
